org.cpsolver.studentsct.reservation

## Class LearningCommunityReservation

- java.lang.Object
- - org.cpsolver.ifs.assignment.context.AbstractClassWithContext<Request,Enrollment,Reservation.ReservationContext>
  - - org.cpsolver.studentsct.reservation.Reservation
    - - org.cpsolver.studentsct.reservation.IndividualReservation
      - - org.cpsolver.studentsct.reservation.GroupReservation
        - - org.cpsolver.studentsct.reservation.LearningCommunityReservation

- All Implemented Interfaces:
    Comparable<Reservation>, AssignmentComparable<Reservation,Request,Enrollment>, CanHoldContext, CanInheritContext<Request,Enrollment,Reservation.ReservationContext>, HasAssignmentContext<Request,Enrollment,Reservation.ReservationContext>

      public class LearningCommunityReservation
      extends GroupReservation

  Learning Community reservation. This is a combination of `GroupReservation` and `CourseReservation`. Space is reserved for students of a group but only when they enroll into the offering through the given course.
  Version:
    StudentSct 1.3 (Student Sectioning)
    Copyright (C) 2007 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.cpsolver.studentsct.reservation.Reservation

      `Reservation.ReservationContext`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static boolean` | `DEFAULT_ALLOW_OVERLAP` Overlaps are not allowed for Learning Community reservations.
    `static boolean` | `DEFAULT_CAN_ASSIGN_OVER_LIMIT` Learning Community reservations cannot be assigned over the limit.
    `static boolean` | `DEFAULT_MUST_BE_USED` Learning Community reservation must be used (unless it is expired)
    `static int` | `DEFAULT_PRIORITY` Learning Community reservations are just a below student group reservations.

    - ### Fields inherited from interface org.cpsolver.ifs.assignment.context.CanHoldContext

      `sMaxSize`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LearningCommunityReservation(long id, double limit, Course course, Collection<Long> studentIds)` Constructor
    `LearningCommunityReservation(long id, double limit, Course course, Long... studentIds)` Constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Course` | `getCourse()` Course offering
    `double` | `getReservationLimit()` Reservation limit (-1 for unlimited)
    `boolean` | `isApplicable(Student student, Course course)` Check the student group and the course

    - ### Methods inherited from class org.cpsolver.studentsct.reservation.GroupReservation

      `setReservationLimit`

    - ### Methods inherited from class org.cpsolver.studentsct.reservation.IndividualReservation

      `getStudentIds`

    - ### Methods inherited from class org.cpsolver.studentsct.reservation.Reservation

      `addConfig, addSection, addSection, areRestrictionsInclusive, canAssignOverLimit, canBatchAssignOverLimit, canBreakLinkedSections, canEnroll, compareTo, compareTo, createAssignmentContext, getConfigs, getEnrollments, getId, getLimit, getLimit, getLimitCap, getLimitCap, getModel, getOffering, getPriority, getReservedAvailableSpace, getReservedAvailableSpace, getRestrictivity, getSections, getSections, inheritAssignmentContext, isAllowDisabled, isAllowOverlap, isApplicable, isExpired, isIncluded, mustBeUsed, mustBeUsedIgnoreExpiration, neverIncluded, setAllowDisabled, setAllowOverlap, setBreakLinkedSections, setCanAssignOverLimit, setExpired, setMustBeUsed, setNeverIncluded, setPriority`

    - ### Methods inherited from class org.cpsolver.ifs.assignment.context.AbstractClassWithContext

      `getAssignmentContextReference, getContext, getContext, setAssignmentContextReference`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_PRIORITY

          public static final int DEFAULT_PRIORITY

      Learning Community reservations are just a below student group reservations.
      See Also:
        Constant Field Values

    - #### DEFAULT_MUST_BE_USED

          public static final boolean DEFAULT_MUST_BE_USED

      Learning Community reservation must be used (unless it is expired)
      See Also:
        Constant Field Values

    - #### DEFAULT_CAN_ASSIGN_OVER_LIMIT

          public static final boolean DEFAULT_CAN_ASSIGN_OVER_LIMIT

      Learning Community reservations cannot be assigned over the limit.
      See Also:
        Constant Field Values

    - #### DEFAULT_ALLOW_OVERLAP

          public static final boolean DEFAULT_ALLOW_OVERLAP

      Overlaps are not allowed for Learning Community reservations.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### LearningCommunityReservation

          public LearningCommunityReservation(long id,
                                              double limit,
                                              Course course,
                                              Long... studentIds)

      Constructor
      Parameters:
        `id` - unique id
        `limit` - reservation limit (-1 for unlimited)
        `course` - course offering for which the reservation is
        `studentIds` - one or more students

    - #### LearningCommunityReservation

          public LearningCommunityReservation(long id,
                                              double limit,
                                              Course course,
                                              Collection<Long> studentIds)

      Constructor
      Parameters:
        `id` - unique id
        `limit` - reservation limit (-1 for unlimited)
        `course` - course offering for which the reservation is
        `studentIds` - one or more students

  - ### Method Detail

    - #### getReservationLimit

          public double getReservationLimit()

      Reservation limit (-1 for unlimited)
      Overrides:
        `getReservationLimit` in class `GroupReservation`
      Returns:
        reservation limit, -1 for unlimited

    - #### getCourse

          public Course getCourse()

      Course offering
      Returns:
        course offering

    - #### isApplicable

          public boolean isApplicable(Student student,
                                      Course course)

      Check the student group and the course
      Overrides:
        `isApplicable` in class `IndividualReservation`
      Parameters:
        `student` - a student
        `course` - a course
      Returns:
        true if student can use the reservation to get into the course / configuration / section